
// C̋Lq

#include "stdafx.h"
#include "udnm.h"

#include <stdio.h>
#include <mmsystem.h>
#include <winsock2.h>
#include <iphlpapi.h>

#pragma comment( lib, "winmm.lib" )
#pragma comment( lib, "Iphlpapi.lib" )

// DLL̃CX^X
HMODULE hMod = NULL;

//CEChEƁATXyh`FbNp̃_~[EChE
static HWND hMainWindow = NULL;
static HWND hTopWindow = NULL;
//`p
static HDC hBackDC = NULL;
static HBITMAP hBackBM = NULL, hBackOBM;

static unsigned int timer = 0; //^C}[ID
static const wchar_t Window_Class[] = L"NetMon_Plugin";

static const int interval = 200; //f[^擾Ԋu
static const int period = 200; //ő\
static const int num_entries = period * 1000 / interval; //őf[^
static const int window_width = num_entries;
static const int window_height = 16;

static HANDLE DrawMutex = NULL; //`̔rp


//
struct Snapshot {
	unsigned long time;
	__int64       total_recv;
	__int64       total_send;
	int           recv_per_sec;
	int           send_per_sec;
};

static Snapshot stat[num_entries];
int stat_pos;

//_ł̍vrecv/sendʂ擾
void GetIFStatus(Snapshot* ss) { 
	unsigned long size = 0;
	PMIB_IFTABLE ifTable;

	ss->time = timeGetTime();
	ss->total_recv = ss->total_send = ss->recv_per_sec = ss->send_per_sec = 0;

	if (GetIfTable(NULL, &size, 0) == ERROR_NOT_SUPPORTED)
		return;
	ifTable = (PMIB_IFTABLE) new char[size];
	
	//eC^[tF[X̑MʂZ
	if (GetIfTable(ifTable, &size, 0) == NO_ERROR){
		for(unsigned int i = 0; i < ifTable->dwNumEntries; i++) {
			ss->total_recv += ifTable->table[i].dwInOctets;
			ss->total_send += ifTable->table[i].dwOutOctets;
		}
	}

	delete ifTable;
}


// vf[^
void InitializeData() {
	Snapshot ss;

	GetIFStatus(&ss);
	stat[0] = ss;
	stat_pos = 0;

	//ߋ̃f[^́ȂMʂŖ߂Ă
	for(int i=1; i<num_entries; i++) {
		stat[i] = ss;
		stat[i].time = ss.time - (num_entries-i)*interval;
	}
}




//EChE쐬
HWND CreateMainWindow(HWND hWndParent) {
	HDC hdc;

	// EBhENX`
	WNDCLASS wcex;
	wcex.style			= 0;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hMod;
	wcex.hIcon			= 0;
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= 0;
	wcex.lpszMenuName	= 0;
	wcex.lpszClassName	= Window_Class;

	if(!RegisterClass(&wcex)) return NULL;

	// EBhEJ
	hMainWindow = CreateWindowEx(WS_EX_LEFT, Window_Class,
        Window_Class, WS_CHILD, CW_USEDEFAULT, CW_USEDEFAULT,
		window_width, window_height, hWndParent, NULL, NULL, NULL);

	if(hMainWindow == NULL)
		return NULL;
	
	//TXyhĎp̃_~[EChE
	hTopWindow = CreateWindowEx(WS_EX_LEFT, Window_Class,
        Window_Class, 0, CW_USEDEFAULT, CW_USEDEFAULT,
		window_width, window_height, NULL, NULL, NULL, NULL);

	if(hTopWindow == NULL)
		goto err;
	
	//h~pɁA_uobt@̗ʂ쐬
	hdc = GetDC(hMainWindow);
	hBackDC = CreateCompatibleDC(hdc);
	hBackBM = CreateCompatibleBitmap(hdc,window_width,window_height);
	ReleaseDC(hMainWindow,hdc);

	if(!hBackDC || !hBackBM)
		goto err;

	hBackOBM = (HBITMAP)SelectObject(hBackDC, (HGDIOBJ)hBackBM);

	//f[^
	InitializeData();
	
	DrawMutex = CreateMutex(NULL, FALSE, NULL);

	//}`fBA^C}[N
	timeBeginPeriod(10);
	timer = timeSetEvent(interval, 10, TimeProc, 0, TIME_PERIODIC);
	if(timer == 0)
		goto err;

	// EBhE\
	ShowWindow(hMainWindow, SW_SHOW);
	UpdateWindow(hMainWindow);

	return hMainWindow;
err:
	DeleteMainWindow();
	return NULL;
}

//I
void DeleteMainWindow() {
	
	if(timer) {
		timeKillEvent(timer);
		timeEndPeriod(10);
		timer = 0;
	}

	if(DrawMutex) {
		CloseHandle(DrawMutex);
		DrawMutex = NULL;
	}

	if(hMainWindow) {

		if(hTopWindow) {
			DestroyWindow(hTopWindow);
			hTopWindow = NULL;
		}

		if(hBackBM) {
			SelectObject(hBackDC, hBackOBM);
			DeleteObject(hBackOBM);
			hBackBM = NULL;
		}

		if(hBackDC) {
			DeleteDC(hBackDC);
			hBackDC = NULL;
		}
		DestroyWindow(hMainWindow);
		hMainWindow = NULL;
	}

}

//bZ[W
//CEChEƃTXyhĎEChEŎ󂯂
LRESULT CALLBACK WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam){

	//ĕ`
	if(hwnd == hMainWindow) {
		if(msg==WM_SIZE || msg==WM_PAINT)
			DrawStatus(hwnd);
	}

	//TXyh΍
	if(hwnd == hTopWindow && msg == WM_POWERBROADCAST) {
		if (wParam == PBT_APMSUSPEND && timer) {
			//TXyhɂ͈U^C}[폜
			timeKillEvent(timer);
			timeEndPeriod(10);
			timer = 0;
		}
		else if (wParam == PBT_APMRESUMESUSPEND) {
			//W[ɍĊJ
			timeBeginPeriod(10);
			timer = timeSetEvent(interval, 10, TimeProc, 0, TIME_PERIODIC);
		}
	}

	return DefWindowProc(hwnd, msg, wParam, lParam);
}

void DrawStatus(HWND hwnd) {
	RECT r;
	int width,height,i;
	HDC hdc;
	HPEN pen;
	HFONT ofont;
	float recv,send;
	wchar_t str[256];
	Snapshot *ss;

	//EChEbZ[Wƃ}`fBA^C}
	//Xbh瓯˓h
	if(WaitForSingleObject(DrawMutex, 0) != 0)
		return;




	//EChETCY擾
	GetClientRect(hwnd,&r);
	width = r.right;
	height = window_height;

	//wihԂ
	//ȂBitBltȒP
	BitBlt(hBackDC,0,0,width,height,0,0,0,BLACKNESS);

	//⏕
	pen = (HPEN)SelectObject(hBackDC, CreatePen(PS_SOLID, 1, 0xBF0000));
	//
	for(i=0;i<4;i++) {
		MoveToEx(hBackDC,0,(height-1)*i/3,NULL);
		LineTo(hBackDC,width,(height-1)*i/3);
	}
	//c
	for(i=0;i<num_entries;i+=1000/interval) {
		MoveToEx(hBackDC,i,0,NULL);
		LineTo(hBackDC,i,height);
	}
	DeleteObject(SelectObject(hBackDC, pen));

	//`̏߂
	int max_tp = 0;
	for(i=0;i<width && i<num_entries;i++) {
		ss = &stat[(stat_pos + (num_entries - i)) % num_entries];

		if(ss->recv_per_sec > max_tp) max_tp = ss->recv_per_sec;
		if(ss->send_per_sec > max_tp) max_tp = ss->send_per_sec;
	}

	//Ot̏́H
	int graph_max = 1024; // 1KBX^[g
	while(graph_max < max_tp && graph_max<0x40000000) graph_max *= 2;

	
	//MEMOt`

	//M
	pen = (HPEN)SelectObject(hBackDC, CreatePen(PS_SOLID, 1, 0x7F7FFF));
	for(i=0;i<width && i<num_entries;i++) {
		ss = &stat[(stat_pos + (num_entries - i)) % num_entries];
		int h = (height-1) - ss->recv_per_sec*(height-1)/graph_max;

		if(i==0) MoveToEx(hBackDC,0,h,NULL);
		LineTo(hBackDC, i, h);
	}

	//M
	DeleteObject( SelectObject(hBackDC, CreatePen(PS_SOLID, 1, 0xFF7F7F)));
	for(i=0;i<width && i<num_entries;i++) {
		ss = &stat[(stat_pos + (num_entries - i)) % num_entries];
		int h = (height-1) - ss->send_per_sec*(height-1)/graph_max;

		if(i==0) MoveToEx(hBackDC,0,h,NULL);
		LineTo(hBackDC, i, h);
	}
	DeleteObject(SelectObject(hBackDC, pen));
	
	//`
	SetBkMode(hBackDC, TRANSPARENT);
	recv = stat[stat_pos].recv_per_sec / 1024.0f;
	send = stat[stat_pos].send_per_sec / 1024.0f;
	swprintf_s(str, 255, L"R %6.1fK / S %6.1fK", recv, send);

	ofont = (HFONT)SelectObject(hBackDC, CreateFont(10,0,0,0,FW_NORMAL,0,0,0,0,0,0,0,0,L"lr SVbN"));
	SetTextColor(hBackDC, 0x0);
	TextOut(hBackDC, 2, 0, str, (int)wcslen(str));
	SetTextColor(hBackDC, 0xffffff);
	TextOut(hBackDC, 1, -1, str, (int)wcslen(str));
	DeleteObject(SelectObject(hBackDC, ofont));

	//Ōɗʂ\ɓ]
	hdc = GetDC(hwnd);
	if(hdc){
		BitBlt(hdc,0,0,width,height,hBackDC,0,0,SRCCOPY);
		if(width > window_width)
			BitBlt(hdc,window_width,0,width-window_width,height,0,0,0,BLACKNESS);
		ReleaseDC(hwnd,hdc);
	}
	ReleaseMutex(DrawMutex);
}

//^C}[Cxg
void CALLBACK TimeProc(UINT IDEvent,UINT uReserved,DWORD dwUser,DWORD dwReserved1,DWORD dwReserved2) {
	Snapshot *ss, *oss;

	//Vf[^ǉčĕ`
	stat_pos = (stat_pos+1) % num_entries;
	ss = &stat[stat_pos];
	GetIFStatus(ss);
	
	//vZ
	//1bÕf[^
	oss = &stat[(stat_pos + num_entries - 1000/interval) % num_entries];
	unsigned long span = ss->time - oss->time;
	
	//Ô߁AZԊuŌĂ΂ꂽ疳
	if(span < 1) {
		stat_pos = (stat_pos + num_entries -1) % num_entries;
		return;
	}
	ss->recv_per_sec = (int)((ss->total_recv - oss->total_recv) * 1000 / span);
	ss->send_per_sec = (int)((ss->total_send - oss->total_send) * 1000 / span);

	//ĕ`
	DrawStatus(hMainWindow);
}
	